#include "TGeoManager.h"
#include "TGeoMedium.h"
#include "TGeoVolume.h"
#include "TGeoNode.h"
#include "TFile.h"
#include "TTree.h"
   
void stat() {
   //gROOT->ProcessLine(".x /user/brun/rootcmz/geo/cmsecal2.C");
   TFile f("statg3.root");
   TTree *T = (TTree*)f.Get("stat");
   Float_t x[6], oldstep, oldsafety;
   Int_t statcode;
   Double_t statsafety, statsnext;
   T->SetBranchAddress("statcode",&statcode);
   T->SetBranchAddress("oldvect",x);
   T->SetBranchAddress("oldsafety",&oldsafety);
   T->SetBranchAddress("oldstep",&oldstep);
   T->SetBranchAddress("snext",&statsnext);
   T->SetBranchAddress("safety",&statsafety);
            Int_t numed,nlevel;
            Int_t isame,number[30],lvolum[30],names[100];
   
   Int_t nentries = (Int_t)T->GetEntries();
    TGeoNode *gCurrentNode = 0;
    TGeoVolume *vol=0;
    TGeoMedium *medium =0;
    
   for (Int_t i=0;i<nentries;i++) {
      T->GetEntry(i);
      //if(statcode <10) continue;
      switch(statcode) {
         case 0: {
            if (gGeoManager->IsSameLocation(x[0], x[1], x[2])) isame = 1;
            else isame = 0;
            break;
         }
         
         case 1: {
            gCurrentNode = gGeoManager->FindNode(x[0],x[1],x[2]);
            if (!gCurrentNode) {numed=0; break;}
            nlevel = 1 + gGeoManager->GetLevel();
            gGeoManager->GetBranchNames(names);
            //gGeoManager->GetBranchNumbers(gcvolu->number,gcvolu->lvolum);
            gGeoManager->GetBranchNumbers(number,lvolum);
            vol = gCurrentNode->GetVolume();
            if (vol) {
               medium = vol->GetMedium();
               if (medium) numed = medium->GetId();
            } else {
               printf("found case with vol=0 in gmedia\n");
            }
            break;
         }
         
         case 2: {
            gCurrentNode = gGeoManager->FindNode(x[0],x[1],x[2]);
           if (!gCurrentNode) {numed=0; break;}
            nlevel = 1 + gGeoManager->GetLevel();
            gGeoManager->GetBranchNames(names);
            gGeoManager->GetBranchNumbers(number,lvolum);
            vol = gCurrentNode->GetVolume();
            //gcchan->lsamvl = gGeoManager->IsSameLocation();   
            Bool_t lsamvl = gGeoManager->IsSameLocation();   
            if (vol) {
               medium = vol->GetMedium();
               if (medium) numed = medium->GetId();
            } else {
               printf("found case with vol=0 in gtmedi\n");
            }
            break;
         }
         
         case 3: {
            Double_t step = oldstep;
            //Float_t *x = gctrak->vect;
   
            gGeoManager->SetCurrentPoint(x[0],x[1],x[2]);
            gGeoManager->SetCurrentDirection(x[3],x[4],x[5]);

            if (!gGeoManager->IsSameLocation(x[0],x[1],x[2])) {
               double safety = 0.;
               double snext = 0.;
               int ignext = 1;
            }
            break;
         }
      }
   }
}
